﻿Public Class fMain

    Private FileNum As Integer

    Private Sub cmdAcquire_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAcquire.Click

        Dim Cancel As Boolean

        Cancel = False

        With AxImageBox1
            If .SelectTwainDevice Then
                If Not .HasADF Then
                    If MsgBox("No ADF detected on this device.  Continue?", vbOKCancel) = vbCancel Then
                        Cancel = True
                    End If
                End If
            Else
                Cancel = True
            End If

            If Not Cancel Then
                .TwainMultiImage = True
                .UseADF = True
                If cboPages.Text = "Max." Then
                    ' Continues acquiring images until ADF is empty
                    .TwainImagesToRead = 0
                Else
                    .TwainImagesToRead = cboPages.Text
                End If
                ' This value is the tolerance for defining a blank page.  It is set to a high value to ensure this demo will
                ' work well even with colour scanning using sheets that are not pure white.
                ' For black and white scanning with plain white separator pages a lower value (e.g., 100) is appropriate.
                .BlankTol = 10000
                .ClearTIF()
                .UseTwainInterface = chkUI.Checked
                .TwainDuplexEnabled = chkDuplex.Checked

                .Acquire()

                If rdbMulti.Checked Then
                    .WriteTIF(txtFileName.Text & ".tif")
                End If

                If rdbSep.Checked Then
                    .WriteTIF(txtFileName.Text & Trim(Str(FileNum)) & ".tif")
                End If

            End If

        End With

    End Sub

    Private Sub fMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim i As Integer

        With cboPages
            .Items.Clear()
            For i = 1 To 5
                .Items.Add(i)
            Next i
            .Items.Add(10)
            .Items.Add(20)
            .Items.Add("Max.")
            .SelectedIndex = 1
        End With

        FileNum = 1

    End Sub

    Private Sub AxImageBox1_OnAcquire(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AxImageBox1.OnAcquire

        ' Redraw the control to display the current image
        AxImageBox1.Redraw()

        If rdbSingle.Checked Then

            ' Save image as an individual file
            AxImageBox1.SaveToFile(txtFileName.Text & Trim(Str(FileNum)) & ".tif")
            FileNum = FileNum + 1

        ElseIf rdbMulti.Checked Then

            ' Save multi-page TIFF file
            ' Use Group 4 compression for black & white images
            If AxImageBox1.ColorFormat = csXImageTrial.TxColorFormat.cfMonoBW Then
                AxImageBox1.Compression = csXImageTrial.TxCompression.cmGroup4
            End If
            AxImageBox1.AddToTIF(0)

        Else

            If AxImageBox1.IsBlank Then
                AxImageBox1.WriteTIF(txtFileName.Text & Trim(Str(FileNum)) & ".tif")
                FileNum = FileNum + 1
                AxImageBox1.ClearTIF()
            Else
                AxImageBox1.AddToTIF(0)
            End If

        End If

    End Sub

End Class
